 /****************************************************************************
 **  CUBE        http://www.scalasca.org/                                   **
 **  SCALASCA    http://www.scalasca.org/                                   **
 *****************************************************************************
 **  Copyright (c) 2011-2014                                                **
 **  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
 **                                                                         **
 **  See the file COPYRIGHT in the package base directory for details       **
 ****************************************************************************/

package scalasca.cubex.cube;
import java.lang.*;
import java.util.*;
/*
 * Class , delivers file structure of CubeX
 * 
 */
public class SystemTreeNode extends NamedVertex
{
	protected String description = "";
	protected String stn_class = "";
	
	protected ArrayList< LocationGroup > groups= new ArrayList<LocationGroup> ();
//     @SuppressWarnings("unchecked")
	public SystemTreeNode() {  super("Machine");  }
	public SystemTreeNode(int _id, SystemTreeNode parent) {super(_id, (parent == null)?"Machine":"Node", parent); }
	public SystemTreeNode(int _id, String _name, String _class, SystemTreeNode parent) {super(_id, _name, parent); stn_class = _class; }
	public SystemTreeNode(int _id, String _name, String _description, String _class ) {super(_id, _name, null); description = _description; stn_class = _class; }
	public SystemTreeNode(int _id, String _name, String _description, String _class, SystemTreeNode parent) {super(_id, _name, parent); description = _description; stn_class = _class; }

	public String getDescription() { return description; }
	public void init(String  _name, String _description, String _class) { setName(_name); description = _description; stn_class = _class; }
	
	
	
	public void addLocationGroup(LocationGroup _lg)
	{
		groups.add(_lg);
	}

	public LocationGroup getLocationGroup(int idx)
	{
	// 	if (idx >0 && idx < children.size())
		return groups.get(idx);
	// 	throw new ArrayIndexOutOfBoundsException();
	}

	public int getNumberOfGroups()
	{
		return groups.size();
	}

	public String getSystemTreeNodeClass()
	{
	    return stn_class;
	}

	public ArrayList<LocationGroup> getAllGroups() { return groups; }


	
}
