/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2011-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2011-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

package scalasca.cubex.cubexlayout;
import scalasca.cubex.tarviewer.*;
import java.io.FileInputStream;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.util.zip.*;
import scalasca.cubex.cube.errors.*;
/*
 * Class , delivers file structure of CubeX
 * 
 */
public class Cube3GZIPLayout extends CubeLayout
{

// 	@SuppressWarnings("unchecked")
	public Cube3GZIPLayout(String filename)
	{
		super(filename);
	}




	public void print()
	{
		System.out.println(" ====== Simply gzipped cube3  layout  ========");
		System.out.println("Anchor size:      " + AnchorSize);
		System.out.println("Anchor offset:   " + AnchorShift);

	}


	static boolean testLayout(String _filename)
	{
		try
		{
			GZIPInputStream  fis = new GZIPInputStream(new FileInputStream(_filename));
			byte buffer[] = new byte[1024];
			fis.read(buffer);
		}
		catch (FileNotFoundException e) // data corrupt - not gzipped
		{
			return false;
		}
		catch (IOException e) // data corrupt - not gzipped
		{
			return false;
		}
		return true;  // so far ? data is gipped
	}

	public byte[] getAnchorBytes() throws IOException
	{
		try
		{
			GZIPInputStream  fis = new GZIPInputStream(new FileInputStream(filename));
			ByteArrayOutputStream b_out = new ByteArrayOutputStream();

			byte buffer[] = new byte[1*1024*1024];

			while(fis.available() != 0 )
			{
				int readed = fis.read(buffer);
				if (readed == -1)
					break;
				b_out.write(buffer, 0, readed);
			}
			fis.close();
			return b_out.toByteArray();
		}catch (FileNotFoundException e)
		{ 
			System.out.println("File " + filename + " not found.");
			return new byte[0];
		}
	}

}
